local modPath = 'FinalRushPro3'

local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Group = import('/lua/maui/group.lua').Group
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local Button = import('/lua/maui/button.lua').Button
local Checkbox = import('/lua/maui/checkbox.lua').Checkbox
local StatusBar = import('/lua/maui/statusbar.lua').StatusBar
local GameMain = import('/lua/ui/game/gamemain.lua')
local Tooltip = import('/lua/ui/game/tooltip.lua')
local Prefs = import('/lua/user/prefs.lua')
local Tooltip = import('/lua/ui/game/tooltip.lua')

DataFromSync = false
local AggroData = {}

local CivAttackEasy = {
		t1spawndelay = 0,
		t2spawndelay = 6  * 60,
		t3spawndelay = 12 * 60,
		t4spawndelay = 18 * 60,
		hunterdelay  = 24 * 60,
		t1frequency = 6,
		t2frequency = 6,
		t3frequency = 10,
		t4frequency = 30,
		hunterfrequency = 4 * 60,
		RandomFrequency = 90
}

local CivAttackNormal = {
		t1spawndelay = 0,
		t2spawndelay = 6  * 60,
		t3spawndelay = 12 * 60,
		t4spawndelay = 18 * 60,
		hunterdelay  = 22 * 60,
		t1frequency = 6,
		t2frequency = 6,
		t3frequency = 10,
		t4frequency = 10,
		hunterfrequency = 3 * 60,
		RandomFrequency = 70
}

local CivAttackHard = {
		t1spawndelay = 0,
		t2spawndelay = 5  * 60,
		t3spawndelay = 10 * 60,
		t4spawndelay = 16 * 60,
		hunterdelay  = 18 * 60,
		t1frequency = 6,
		t2frequency = 6,
		t3frequency = 10,
		t4frequency = 10,
		hunterfrequency = 2 * 60,
		RandomFrequency = 50
}

local CivAttackInsane = {
		t1spawndelay = 0,
		t2spawndelay = 4 * 60,
		t3spawndelay = 8 * 60,
		t4spawndelay = 14 * 60,
		hunterdelay  = 16 * 60,
		t1frequency = 6,
		t2frequency = 6,
		t3frequency = 10,
		t4frequency = 8,
		hunterfrequency = 90,
		RandomFrequency = 30
}


RushUI = {
	arrow = false,
	box = false
}

parent = false

function CreateModUI(isReplay, _parent)
	parent = _parent
	
	CreateRushUI()
	CommonLogic()
end

function CreateRushUI()
	-- Create group for main UI
	local PanelOffset = { X = 16, Y = 153 } 
	local PanelSize = {
		Top = { Width = 250, Height = 36 },
		Center = { Width = 250, Height = 264 }, --correct
		Bottom = { Width = 250, Height = 20 }
	}
	
	RushUI.box = Group(parent)
	LayoutHelpers.AtLeftTopIn(RushUI.box, parent, PanelOffset.X , PanelOffset.Y)
	
	RushUI.box.Top = Bitmap(RushUI.box)
	RushUI.box.Top:SetTexture(UIUtil.UIFile('/game/score-panel/panel-score_bmp_t.dds'))
	RushUI.box.Top.Height:Set(PanelSize.Top.Height)
	RushUI.box.Top.Width:Set(PanelSize.Top.Width)
	LayoutHelpers.AtLeftTopIn(RushUI.box.Top, parent, PanelOffset.X, PanelOffset.Y)
	
	RushUI.box.panel = Bitmap(RushUI.box)
	RushUI.box.panel:SetTexture(UIUtil.UIFile('/game/score-panel/panel-score_bmp_m.dds'))
	RushUI.box.panel.Height:Set(PanelSize.Center.Height)
	RushUI.box.panel.Width:Set(PanelSize.Center.Width)
	LayoutHelpers.AtLeftTopIn(RushUI.box.panel, parent, PanelOffset.X, PanelOffset.Y + PanelSize.Top.Height)
	
	RushUI.box.Bottom = Bitmap(RushUI.box)
	RushUI.box.Bottom:SetTexture(UIUtil.UIFile('/game/score-panel/panel-score_bmp_b.dds'))
	RushUI.box.Bottom.Height:Set(PanelSize.Bottom.Height)
	RushUI.box.Bottom.Width:Set(PanelSize.Bottom.Width)
	LayoutHelpers.AtLeftTopIn(RushUI.box.Bottom, parent, PanelOffset.X, PanelOffset.Y + PanelSize.Top.Height + PanelSize.Center.Height)
		
	-- Create arrow checkbox
	RushUI.arrow = Checkbox(parent)
	
	-- Assign layout info to arrow checkbox
	RushUI.arrow:SetTexture(UIUtil.UIFile('/game/tab-l-btn/tab-close_btn_up.dds'))
	RushUI.arrow:SetNewTextures(UIUtil.UIFile('/game/tab-l-btn/tab-close_btn_up.dds'),
		UIUtil.UIFile('/game/tab-l-btn/tab-open_btn_up.dds'),
		UIUtil.UIFile('/game/tab-l-btn/tab-close_btn_over.dds'),
		UIUtil.UIFile('/game/tab-l-btn/tab-open_btn_over.dds'),
		UIUtil.UIFile('/game/tab-l-btn/tab-close_btn_dis.dds'),
		UIUtil.UIFile('/game/tab-l-btn/tab-open_btn_dis.dds'))
		
	LayoutHelpers.AtLeftTopIn(RushUI.arrow, GetFrame(0), -3,  PanelOffset.Y + 12)
	RushUI.arrow.Depth:Set(function() return RushUI.box.Depth() + 10 end)
	
	RushUI.box.Height:Set(RushUI.box.panel.Height) --sets outer border leave as is.
	RushUI.box.Width:Set(RushUI.box.panel.Width)
		
	RushUI.box:DisableHitTest()

	--Left Glow Outline
	RushUI.box.leftBracketMid = Bitmap(RushUI.box)
    RushUI.box.leftBracketMid:SetTexture(UIUtil.UIFile('/game/bracket-left/bracket_bmp_m.dds'))
    LayoutHelpers.AtLeftTopIn(RushUI.box.leftBracketMid, parent, 10, PanelOffset.Y + 25)
	RushUI.box.leftBracketMid.Height:Set(275)
	
	RushUI.box.leftBracketMin = Bitmap(RushUI.box)
    RushUI.box.leftBracketMin:SetTexture(UIUtil.UIFile('/game/bracket-left/bracket_bmp_t.dds'))
    LayoutHelpers.AtLeftTopIn(RushUI.box.leftBracketMin, parent, 3, PanelOffset.Y - 5)
	RushUI.box.leftBracketMin.Height:Set(30)

    
	RushUI.box.leftBracketMax = Bitmap(RushUI.box)
    RushUI.box.leftBracketMax:SetTexture(UIUtil.UIFile('/game/bracket-left/bracket_bmp_b.dds'))
    LayoutHelpers.AtLeftTopIn(RushUI.box.leftBracketMax, parent, 3, PanelOffset.Y + PanelSize.Top.Height + PanelSize.Center.Height)
	RushUI.box.leftBracketMax.Height:Set(30)
    
	
	--Right Glow Outline
	RushUI.box.rightBracketMin = Bitmap(RushUI.box)
	RushUI.box.rightBracketMin:SetTexture(UIUtil.UIFile('/game/bracket-right-energy/bracket_bmp_t.dds'))
    LayoutHelpers.AtLeftTopIn(RushUI.box.rightBracketMin, parent, PanelSize.Top.Width + 2, PanelOffset.Y)
	RushUI.box.rightBracketMin.Height:Set(10)
    
	RushUI.box.rightBracketMax = Bitmap(RushUI.box)
    RushUI.box.rightBracketMax:SetTexture(UIUtil.UIFile('/game/bracket-right-energy/bracket_bmp_b.dds'))
	LayoutHelpers.AtLeftTopIn(RushUI.box.rightBracketMax, parent, PanelSize.Top.Width + 2, PanelOffset.Y + PanelSize.Top.Height + PanelSize.Center.Height + 10)
	RushUI.box.rightBracketMax.Height:Set(10)
	
    RushUI.box.rightBracketMid = Bitmap(RushUI.box)
    RushUI.box.rightBracketMid:SetTexture(UIUtil.UIFile('/game/bracket-right-energy/bracket_bmp_m.dds'))
	LayoutHelpers.AtLeftTopIn(RushUI.box.rightBracketMid, parent, PanelSize.Top.Width + 10, PanelOffset.Y + 10)
	RushUI.box.rightBracketMid.Height:Set(300)

	
	
	-- Hide panel
	RushUI.box:Hide()
	RushUI.arrow:SetCheck(true, true)
	RushUI.box.Left:Set(parent.Left()-RushUI.box.Width())
	
	-- Text
	AddTextToPanel()
end

function AddTextToPanel()
	RushUI.box.titlemain = UIUtil.CreateText(RushUI.box, 'Final Rush Pro3', 12, UIUtil.bodyFont)
	RushUI.box.titlemain:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.titlemain, RushUI.box.Top, 15, 3)
	RushUI.box.titlemain:SetColor('ffb7e75f')	
	
	
	RushUI.box.title1 = UIUtil.CreateText(RushUI.box, 'Attackers', 18, UIUtil.bodyFont)
	RushUI.box.title1:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.title1, RushUI.box.panel, 15, -10)
	RushUI.box.title1:SetColor('ffb7e75f')
	
	RushUI.box.EnemyTechcountdown = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.EnemyTechcountdown:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.EnemyTechcountdown, RushUI.box.panel, 15, 21)
	RushUI.box.EnemyTechcountdown:SetColor('ffb7e75f')	
	
	RushUI.box.Seperator1 = UIUtil.CreateText(RushUI.box, '-----------------', 14, UIUtil.bodyFont)
	RushUI.box.Seperator1:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.Seperator1, RushUI.box.panel, 15, 34)
	RushUI.box.Seperator1:SetColor('ffb7e75f')	
	
	RushUI.box.EnemyCountNorth = UIUtil.CreateText(RushUI.box, '0', 14, UIUtil.bodyFont)
	RushUI.box.EnemyCountNorth:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.EnemyCountNorth, RushUI.box.panel, 15, 49)
	RushUI.box.EnemyCountNorth:SetColor('ffb7e75f')		
	
	RushUI.box.EnemyCountSouth = UIUtil.CreateText(RushUI.box, '0', 14, UIUtil.bodyFont)
	RushUI.box.EnemyCountSouth:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.EnemyCountSouth, RushUI.box.panel, 15, 63)
	RushUI.box.EnemyCountSouth:SetColor('ffb7e75f')	
	
	RushUI.box.Seperator2 = UIUtil.CreateText(RushUI.box, '-----------------', 14, UIUtil.bodyFont)
	RushUI.box.Seperator2:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.Seperator2, RushUI.box.panel, 15, 77)
	RushUI.box.Seperator2:SetColor('ffb7e75f')
	
	RushUI.box.title2 = UIUtil.CreateText(RushUI.box, 'Players', 18, UIUtil.bodyFont)
	RushUI.box.title2:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.title2, RushUI.box.panel, 15, 95)
	RushUI.box.title2:SetColor('ffb7e75f')
	
	RushUI.box.TechByTimeCountDown = UIUtil.CreateText(RushUI.box, 'All Tech Enabled', 14, UIUtil.bodyFont)
	RushUI.box.TechByTimeCountDown:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.TechByTimeCountDown, RushUI.box.panel, 15, 126)
	RushUI.box.TechByTimeCountDown:SetColor('ffb7e75f')
	
	RushUI.box.KillsSeperator = UIUtil.CreateText(RushUI.box, '----------', 14, UIUtil.bodyFont)
	RushUI.box.KillsSeperator:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsSeperator, RushUI.box.panel, 15, 140)
	RushUI.box.KillsSeperator:SetColor('ffb7e75f')
	
	local scorecol = 210
	local aggrocol = 180
	
	RushUI.box.KillsARMY_1n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_1n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_1n, RushUI.box.panel, 15, 154)
	RushUI.box.KillsARMY_1n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_1a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_1a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_1a, RushUI.box.panel, aggrocol, 154)
	RushUI.box.KillsARMY_1a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_1s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_1s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_1s, RushUI.box.panel, scorecol, 154)
	RushUI.box.KillsARMY_1s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_2n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_2n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_2n, RushUI.box.panel, 15, 168)
	RushUI.box.KillsARMY_2n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_2a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_2a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_2a, RushUI.box.panel, aggrocol, 168)
	RushUI.box.KillsARMY_2a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_2s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_2s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_2s, RushUI.box.panel, scorecol, 168)
	RushUI.box.KillsARMY_2s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_3n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_3n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_3n, RushUI.box.panel, 15, 182)
	RushUI.box.KillsARMY_3n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_3a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_3a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_3a, RushUI.box.panel, aggrocol, 182)
	RushUI.box.KillsARMY_3a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_3s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_3s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_3s, RushUI.box.panel, scorecol, 182)
	RushUI.box.KillsARMY_3s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_4n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_4n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_4n, RushUI.box.panel, 15, 196)
	RushUI.box.KillsARMY_4n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_4a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_4a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_4a, RushUI.box.panel, aggrocol, 196)
	RushUI.box.KillsARMY_4a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_4s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_4s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_4s, RushUI.box.panel, scorecol, 196)
	RushUI.box.KillsARMY_4s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_5n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_5n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_5n, RushUI.box.panel, 15, 210)
	RushUI.box.KillsARMY_5n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_5a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_5a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_5a, RushUI.box.panel, aggrocol, 210)
	RushUI.box.KillsARMY_5a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_5s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_5s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_5s, RushUI.box.panel, scorecol, 210)
	RushUI.box.KillsARMY_5s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_6n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_6n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_6n, RushUI.box.panel, 15, 224)
	RushUI.box.KillsARMY_6n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_6a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_6a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_6a, RushUI.box.panel, aggrocol, 224)
	RushUI.box.KillsARMY_6a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_6s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_6s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_6s, RushUI.box.panel, scorecol, 224)
	RushUI.box.KillsARMY_6s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_7n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_7n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_7n, RushUI.box.panel, 15, 238)
	RushUI.box.KillsARMY_7n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_7a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_7a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_7a, RushUI.box.panel, aggrocol, 238)
	RushUI.box.KillsARMY_7a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_7s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_7s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_7s, RushUI.box.panel, scorecol, 238)
	RushUI.box.KillsARMY_7s:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_8n = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_8n:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_8n, RushUI.box.panel, 15, 252)
	RushUI.box.KillsARMY_8n:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_8a = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_8a:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_8a, RushUI.box.panel, aggrocol, 252)
	RushUI.box.KillsARMY_8a:SetColor('ffb7e75f')
	
	RushUI.box.KillsARMY_8s = UIUtil.CreateText(RushUI.box, '', 14, UIUtil.bodyFont)
	RushUI.box.KillsARMY_8s:SetDropShadow(true)
	LayoutHelpers.AtLeftTopIn(RushUI.box.KillsARMY_8s, RushUI.box.panel, scorecol, 252)
	RushUI.box.KillsARMY_8s:SetColor('ffb7e75f')
end

function CommonLogic()
	# Add heartbeat
	GameMain.AddBeatFunction(RushUIBeat)
	GameMain.AddBeatFunction(InitRushPanel)
	
	RushUI.box.OnDestroy = function(self)
		GameMain.RemoveBeatFunction(RushUIBeat)
	end

	# Button Actions
	RushUI.arrow.OnCheck = function(self, checked)
		ToggleRushPanel()
	end
end

function ReturnCivAttackTiming()
	if SessionGetScenarioInfo().Options.opt_gamemode == 3  or SessionGetScenarioInfo().Options.opt_gamemode == 4 then
		return CivAttackEasy
	elseif SessionGetScenarioInfo().Options.opt_gamemode == 5 then
		return CivAttackNormal
	elseif SessionGetScenarioInfo().Options.opt_gamemode == 6 then
		return CivAttackHard
	end
end

function GetArmySize(army) 
	if DataFromSync then
		if army == "top" then
			return DataFromSync.EnemyTop
		elseif army == "bottom" then
			return DataFromSync.EnemyBottom
		end
	end
end

unlockwait = function()
	if (SessionGetScenarioInfo().Options.opt_timeunlocked == 1) then
		return 60 * 5
    end
	if (SessionGetScenarioInfo().Options.opt_timeunlocked == 2) then
		return 60 * 10
	end
	if (SessionGetScenarioInfo().Options.opt_timeunlocked == 3) then
		return 60 * 15
	end
	if (SessionGetScenarioInfo().Options.opt_timeunlocked == 4) then
		return 60 * 20
	end
end

function RushUIBeat()
	--Survival
	if SessionGetScenarioInfo().Options.opt_gamemode >= 3 then
		-- Enemy Tech Level Timers
		if GetGameTimeSeconds() - ReturnCivAttackTiming().t2spawndelay < 0  then
			timeLeft = ReturnCivAttackTiming().t2spawndelay - GetGameTimeSeconds()
			RushUI.box.EnemyTechcountdown:SetText(string.format("Tech 2 Attacks in:  %02d:%02d", math.floor(timeLeft / 60), math.mod(timeLeft, 60)))
		elseif GetGameTimeSeconds() - ReturnCivAttackTiming().t3spawndelay < 0  then
			timeLeft = ReturnCivAttackTiming().t3spawndelay - GetGameTimeSeconds()
			RushUI.box.EnemyTechcountdown:SetText(string.format("Tech 3 Attacks in:  %02d:%02d", math.floor(timeLeft / 60), math.mod(timeLeft, 60)))
		elseif GetGameTimeSeconds() - ReturnCivAttackTiming().t4spawndelay < 0  then
			timeLeft = ReturnCivAttackTiming().t4spawndelay - GetGameTimeSeconds()
			RushUI.box.EnemyTechcountdown:SetText(string.format("Experimental Attacks in:  %02d:%02d", math.floor(timeLeft / 60), math.mod(timeLeft, 60)))
		elseif GetGameTimeSeconds() - ReturnCivAttackTiming().hunterdelay < 0  then
			timeLeft = ReturnCivAttackTiming().hunterdelay - GetGameTimeSeconds()
			RushUI.box.EnemyTechcountdown:SetText(string.format("Hunter Attacks in:  %02d:%02d", math.floor(timeLeft / 60), math.mod(timeLeft, 60)))
		else
			RushUI.box.EnemyTechcountdown:SetText("----------")
		end
		-- Enemy Army Count
		RushUI.box.EnemyCountNorth:SetText("Northern Attackers: " .. GetArmySize("top"))	
		RushUI.box.EnemyCountSouth:SetText("Southern Attackers: " .. GetArmySize("bottom"))	
		
		-- Army Kills	
		if DataFromSync.PlayerNames.ARMY_1 != "" then
			RushUI.box.KillsARMY_1n:SetText(DataFromSync.PlayerNames.ARMY_1)
			RushUI.box.KillsARMY_1a:SetText(AggroData.Current.Team1.Player1)
			RushUI.box.KillsARMY_1s:SetText(DataFromSync.KillData.ARMY_1)
		end
		if DataFromSync.PlayerNames.ARMY_2 != "" then
			RushUI.box.KillsARMY_2n:SetText(DataFromSync.PlayerNames.ARMY_2)
			RushUI.box.KillsARMY_2a:SetText(AggroData.Current.Team1.Player2)
			RushUI.box.KillsARMY_2s:SetText(DataFromSync.KillData.ARMY_2)
		end
		if DataFromSync.PlayerNames.ARMY_3 != "" then
			RushUI.box.KillsARMY_3n:SetText(DataFromSync.PlayerNames.ARMY_3)
			RushUI.box.KillsARMY_3a:SetText(AggroData.Current.Team1.Player3)
			RushUI.box.KillsARMY_3s:SetText(DataFromSync.KillData.ARMY_3)
		end
		if DataFromSync.PlayerNames.ARMY_4 != "" then
			RushUI.box.KillsARMY_4n:SetText(DataFromSync.PlayerNames.ARMY_4)
			RushUI.box.KillsARMY_4a:SetText(AggroData.Current.Team1.Player4)
			RushUI.box.KillsARMY_4s:SetText(DataFromSync.KillData.ARMY_4)
		end
		if DataFromSync.PlayerNames.ARMY_5 != "" then
			RushUI.box.KillsARMY_5n:SetText(DataFromSync.PlayerNames.ARMY_5)
			RushUI.box.KillsARMY_5a:SetText(AggroData.Current.Team2.Player1)
			RushUI.box.KillsARMY_5s:SetText(DataFromSync.KillData.ARMY_5)
		end
		if DataFromSync.PlayerNames.ARMY_6 != "" then
			RushUI.box.KillsARMY_6n:SetText(DataFromSync.PlayerNames.ARMY_6)
			RushUI.box.KillsARMY_6a:SetText(AggroData.Current.Team2.Player2)
			RushUI.box.KillsARMY_6s:SetText(DataFromSync.KillData.ARMY_6)
		end
		if DataFromSync.PlayerNames.ARMY_7 != "" then
			RushUI.box.KillsARMY_7n:SetText(DataFromSync.PlayerNames.ARMY_7)
			RushUI.box.KillsARMY_7a:SetText(AggroData.Current.Team2.Player3)
			RushUI.box.KillsARMY_7s:SetText(DataFromSync.KillData.ARMY_7)
		end
		if DataFromSync.PlayerNames.ARMY_8 != "" then
			RushUI.box.KillsARMY_8n:SetText(DataFromSync.PlayerNames.ARMY_8)
			RushUI.box.KillsARMY_8a:SetText(AggroData.Current.Team2.Player4)
			RushUI.box.KillsARMY_8s:SetText(DataFromSync.KillData.ARMY_8)
		end
	else
		RushUI.box.EnemyTechcountdown:SetText("----------")
	end
	
	-- Tech By Time
	if SessionGetScenarioInfo().Options.opt_timeunlocked > 0 and GetGameTimeSeconds() - (unlockwait() * 4 ) < 0 then
		if GetGameTimeSeconds() - (unlockwait() * 1) < 0 then
			TechtimeLeft = (unlockwait() * 1) - GetGameTimeSeconds()
			RushUI.box.TechByTimeCountDown:SetText(string.format("Tech 2 unlocked in: %02d:%02d", math.floor(TechtimeLeft / 60), math.mod(TechtimeLeft, 60)))
		elseif GetGameTimeSeconds() - (unlockwait() * 2) < 0 then
			TechtimeLeft = (unlockwait() * 2) - GetGameTimeSeconds()
			RushUI.box.TechByTimeCountDown:SetText(string.format("Tech 3 unlocked in: %02d:%02d", math.floor(TechtimeLeft / 60), math.mod(TechtimeLeft, 60)))
		elseif GetGameTimeSeconds() - (unlockwait() * 3) < 0 then
			TechtimeLeft = (unlockwait() * 3) - GetGameTimeSeconds()
			RushUI.box.TechByTimeCountDown:SetText(string.format("Experimentals unlocked in: %02d:%02d", math.floor(TechtimeLeft / 60), math.mod(TechtimeLeft, 60)))
		end
	end
end

function ToggleRushPanel(state)
	if import('/lua/ui/game/gamemain.lua').gameUIHidden and state != nil then
		return
	end

	if UIUtil.GetAnimationPrefs() then
		if state or RushUI.box:IsHidden() then
			PlaySound(Sound({Cue = "UI_Score_Window_Open", Bank = "Interface"}))
			RushUI.box:Show()
			RushUI.box:SetNeedsFrameUpdate(true)
			RushUI.box.OnFrame = function(self, delta)
				local newLeft = self.Left() + (1000*delta)
				if newLeft > parent.Left()+14 then
					newLeft = parent.Left()+14
					self:SetNeedsFrameUpdate(false)
				end
				self.Left:Set(newLeft)
			end
			RushUI.arrow:SetCheck(false, true)
		else
			PlaySound(Sound({Cue = "UI_Score_Window_Close", Bank = "Interface"}))
			RushUI.box:SetNeedsFrameUpdate(true)
			RushUI.box.OnFrame = function(self, delta)
				local newLeft = self.Left() - (1000*delta)
				if newLeft < parent.Left()-self.Width() then
					newLeft = parent.Left()-self.Width()
					self:SetNeedsFrameUpdate(false)
					self:Hide()
				end
				self.Left:Set(newLeft)
			end
			RushUI.arrow:SetCheck(true, true)
		end
	else
		if state or RushUI.box:IsHidden() then
			RushUI.box:Show()
			RushUI.arrow:SetCheck(false, true)
		else
			RushUI.box:Hide()
			RushUI.arrow:SetCheck(true, true)
		end
	end
end

function InitRushPanel()
	if import('/lua/ui/game/gamemain.lua').gameUIHidden then
		return
	end
	
	if UIUtil.GetAnimationPrefs() then
		RushUI.box:Show()
		RushUI.box:SetNeedsFrameUpdate(true)
		RushUI.box.OnFrame = function(self, delta)
			local newLeft = self.Left() + (1000*delta)
			if newLeft > parent.Left()+14 then
				newLeft = parent.Left()+14
				self:SetNeedsFrameUpdate(false)
			end
			self.Left:Set(newLeft)
		end
		RushUI.arrow:SetCheck(false, true)

	else
		RushUI.box:Show()
		RushUI.arrow:SetCheck(false, true)	
	end
	GameMain.RemoveBeatFunction(InitRushPanel)
end


function SetDataForUI(data)
	DataFromSync = data
end

function SetAggroForUI(data)
	AggroData = data
end
